* CRMS system version 1.0 - 13 May 2020

* LICENCE
 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License Version 3 as 
* published by the Free Software Foundation.
 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.

* set up environment
* set talk off
set date ansi
SET CENTURY on
set exclusive on
SET ESCAPE on
ON ESCAPE return
MODIFY window screen font "arial",12

clear
clear all

set safety off

* opening display screen and interactive filename capture
?
? "  COVID-19 Rapid Mortality Surveillance System   (version 1.0 20200513)"
?
? "  Note: this is a cause-of-death tool, not intended for symptom assessment in living patients"
?
?
 
select 1
IMPORT from knowbase.xls xls
* set field names from first row
STORE FCOUNT() TO nooff
STORE 1 TO cnt
DO WHILE cnt<=nooff
  STORE FIELD(cnt) TO fold
  STORE &fold TO fnew
  ALTER table knowbase rename &fold to &fnew 
  STORE cnt+1 TO cnt
ENDDO
ALTER table knowbase alter column covid N(5,3)
ALTER table knowbase alter column non_cov N(5,3)
ALTER table knowbase alter column response C(1)
go top
delete next 1
pack
use knowbase
STORE indic TO KB_id
STORE "CRMS1.0" TO PR_id

store "y" to another
do while another="y"

* set up output variables
store 0.5 to prob_cov
store 0.5 to prob_non_cov

select 2
use CRMSoutput
append blank

* get and store id, date/time, gps
store 6 to slno
store "                         " to cid
do while substr(cid,1,1)=" "
  @ slno,5 say "enter case ID " get cid
  read
enddo
replace id with cid
replace start with DATETIME()
* version control 
replace version with "vers "+PR_id+", "+KB_id

* get and store age of deceased
store 999 to age
store 2+slno to slno
select 1
goto 2
do while age<0 .or. age >110
  @ slno,5 say qdesc 
  @ slno,LEN(qdesc)+3 get age
  read
enddo
select 2
replace ageyrs with age

* set conditional probabilities for age in knowbase
select 1
goto 2
replace covid with 0.1+(0.008*age)
replace non_cov with 1-covid

* iterate output variables
select 1
goto 2
store (covid*prob_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_cov
store (non_cov*prob_non_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_non_cov
store prob_cov/(prob_cov+prob_non_cov) to prob_cov
store prob_non_cov/(prob_cov+prob_non_cov) to prob_non_cov

* get and store sex of deceased
select 2
store " " to sex
store 2+slno to slno
SELECT 1
GOTO 3
do while .not. (sex="M" .or. sex="F" .or. sex="D")
  @ slno,5 say qdesc
  @ slno,LEN(qdesc)+3 say "M/F/D" get sex
  read
  store upper(sex) to sex
ENDDO
SELECT 2
replace sexmf with sex 

* iterate output variables
select 1
if sex="M"
  goto 3
endif
if sex="F"
  goto 4
endif
store (covid*prob_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_cov
store (non_cov*prob_non_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_non_cov
store prob_cov/(prob_cov+prob_non_cov) to prob_cov
store prob_non_cov/(prob_cov+prob_non_cov) to prob_non_cov
STORE 1+slno TO slno

* get and store remaining Y/N/D inputs
select 1
goto 5
do while .not. eof()
  store indic to tind
  store qdesc to tq
  select 2
  store " " to inp
  store 1+slno to slno
  do while .not. (inp="Y" .or. inp="N" .or. inp="D")
    @ slno,5 say tq
    @ slno,LEN(tq)+3 say "Y/N/D" get inp
    read
    store upper(inp) to inp
  enddo
  replace &tind with inp 

  * iterate output variables
  select 1
  if inp=response
    store (covid*prob_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_cov
    store (non_cov*prob_non_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_non_cov
    store prob_cov/(prob_cov+prob_non_cov) to prob_cov
    store prob_non_cov/(prob_cov+prob_non_cov) to prob_non_cov
  endif
  skip
  if inp=response
    store (covid*prob_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_cov
    store (non_cov*prob_non_cov)/((covid*prob_cov)+(non_cov*prob_non_cov)) to prob_non_cov
    store prob_cov/(prob_cov+prob_non_cov) to prob_cov
    store prob_non_cov/(prob_cov+prob_non_cov) to prob_non_cov
  endif
  skip
enddo


select 2
replace prob_covid with 100*prob_cov
replace prob_other with 100*prob_non_cov
STORE RTRIM(id)+" "+ttoc(start)+" Probability of death due to COVID-19: "+LTRIM(STR(prob_covid))+"%; other causes: "+LTRIM(STR(prob_other))+"%" TO results

@ 23,5 say results 
DELETE FILE CRMSoutput.csv
COPY TO CRMSoutput.csv csv

@ 25,5 say "another case? " get another
READ
CLEAR
ENDDO

RETURN






